package ex.hm;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.Distribution;
import blang.core.DistributionAdaptor;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.core.RealDistribution;
import blang.core.RealDistributionAdaptor;
import blang.core.RealVar;
import blang.core.UnivariateModel;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class BetaMeanParam implements Model, UnivariateModel<RealVar> {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public RealVar realization;
    
    private boolean realization_initialized = false;
    
    public BetaMeanParam.Builder setRealization(final RealVar realization) {
      realization_initialized = true;
      this.realization = realization;
      return this;
    }
    
    @Arg
    public RealVar mean;
    
    private boolean mean_initialized = false;
    
    public BetaMeanParam.Builder setMean(final RealVar mean) {
      mean_initialized = true;
      this.mean = mean;
      return this;
    }
    
    @Arg
    public RealVar precision;
    
    private boolean precision_initialized = false;
    
    public BetaMeanParam.Builder setPrecision(final RealVar precision) {
      precision_initialized = true;
      this.precision = precision;
      return this;
    }
    
    public BetaMeanParam build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      if (!fromCommandLine && !realization_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing realization");
      final RealVar __realization = realization;
      if (!fromCommandLine && !mean_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing mean");
      final RealVar __mean = mean;
      if (!fromCommandLine && !precision_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing precision");
      final RealVar __precision = precision;
      // Build the instance after boxing params
      return new BetaMeanParam(
        __realization, 
        new ConstantSupplier(__mean), 
        new ConstantSupplier(__precision)
      );
    }
  }
  
  @DesignatedConstructor
  public static BetaMeanParam.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final RealVar realization;
  
  public RealVar getRealization() {
    return realization;
  }
  
  @Param
  private final Supplier<RealVar> $generated__mean;
  
  public RealVar getMean() {
    return $generated__mean.get();
  }
  
  @Param
  private final Supplier<RealVar> $generated__precision;
  
  public RealVar getPrecision() {
    return $generated__precision.get();
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * realization
   */
  private static RealVar $generated__0(final RealVar realization, final RealVar mean, final RealVar precision) {
    return realization;
  }
  
  /**
   * Auxiliary method generated to translate:
   * mean*precision
   */
  private static RealVar $generated__1(final RealVar mean, final RealVar precision) {
    return new blang.core.RealConstant(((mean).doubleValue() * (precision).doubleValue()));
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1($generated__mean.get(), $generated__precision.get());
    }
    
    public String toString() {
      return "mean*precision";
    }
    
    private final Supplier<RealVar> $generated__mean;
    
    private final Supplier<RealVar> $generated__precision;
    
    public $generated__1_class(final Supplier<RealVar> $generated__mean, final Supplier<RealVar> $generated__precision) {
      this.$generated__mean = $generated__mean;
      this.$generated__precision = $generated__precision;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * (1.0-mean)*precision
   */
  private static RealVar $generated__2(final RealVar mean, final RealVar precision) {
    return new blang.core.RealConstant(((1.0 - (mean).doubleValue()) * (precision).doubleValue()));
  }
  
  public static class $generated__2_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__2($generated__mean.get(), $generated__precision.get());
    }
    
    public String toString() {
      return "(1.0-mean)*precision";
    }
    
    private final Supplier<RealVar> $generated__mean;
    
    private final Supplier<RealVar> $generated__precision;
    
    public $generated__2_class(final Supplier<RealVar> $generated__mean, final Supplier<RealVar> $generated__precision) {
      this.$generated__mean = $generated__mean;
      this.$generated__precision = $generated__precision;
    }
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public BetaMeanParam(@DeboxedName("realization") final RealVar realization, @Param @DeboxedName("mean") final Supplier<RealVar> $generated__mean, @Param @DeboxedName("precision") final Supplier<RealVar> $generated__precision) {
    this.realization = realization;
    this.$generated__mean = $generated__mean;
    this.$generated__precision = $generated__precision;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: realization | mean, precision ~ Beta(mean*precision, (1.0-mean)*precision)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Beta(
          $generated__0(realization, $generated__mean.get(), $generated__precision.get()), 
          new $generated__1_class($generated__mean, $generated__precision), 
          new $generated__2_class($generated__mean, $generated__precision)
        )
        );
    }
    
    return components;
  }
  
  public RealVar realization() {
    return realization;
  }
  
  /**
   * Returns an instance with fixed parameters values and conforming the Distribution interface. 
   * Useful when passing around distributions as parameters, e.g. for Dirichlet Process mixtures. 
   * 
   */
  public static RealDistribution distribution(@Param final RealVar mean, @Param final RealVar precision) {
    UnivariateModel<RealVar> univariateModel = new BetaMeanParam(
      new RealDistributionAdaptor.WritableRealVarImpl(), 
      new ConstantSupplier(mean), 
      new ConstantSupplier(precision)
    );
    Distribution<RealVar> distribution = new DistributionAdaptor(univariateModel);
    return new RealDistributionAdaptor(distribution);
  }
}
