package ex.hm;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.io.GlobalDataSource;
import blang.types.Index;
import blang.types.Plate;
import blang.types.Plated;
import blang.types.StaticUtils;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class Hierarchical implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public GlobalDataSource data;
    
    private boolean data_initialized = false;
    
    public Hierarchical.Builder setData(final GlobalDataSource data) {
      data_initialized = true;
      this.data = data;
      return this;
    }
    
    @Arg
    public Plate<String> rocketType;
    
    private boolean rocketType_initialized = false;
    
    public Hierarchical.Builder setRocketType(final Plate<String> rocketType) {
      rocketType_initialized = true;
      this.rocketType = rocketType;
      return this;
    }
    
    @Arg
    public Plated<IntVar> numberOfLaunches;
    
    private boolean numberOfLaunches_initialized = false;
    
    public Hierarchical.Builder setNumberOfLaunches(final Plated<IntVar> numberOfLaunches) {
      numberOfLaunches_initialized = true;
      this.numberOfLaunches = numberOfLaunches;
      return this;
    }
    
    @Arg
    public Plated<RealVar> failureProbabilities;
    
    private boolean failureProbabilities_initialized = false;
    
    public Hierarchical.Builder setFailureProbabilities(final Plated<RealVar> failureProbabilities) {
      failureProbabilities_initialized = true;
      this.failureProbabilities = failureProbabilities;
      return this;
    }
    
    @Arg
    public Plated<IntVar> numberOfFailures;
    
    private boolean numberOfFailures_initialized = false;
    
    public Hierarchical.Builder setNumberOfFailures(final Plated<IntVar> numberOfFailures) {
      numberOfFailures_initialized = true;
      this.numberOfFailures = numberOfFailures;
      return this;
    }
    
    @Arg
    public Optional<RealVar> mu;
    
    public Hierarchical.Builder setMu(final RealVar mu) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.mu = Optional.of(mu);
      return this;
    }
    
    @Arg
    public Optional<RealVar> s;
    
    public Hierarchical.Builder setS(final RealVar s) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.s = Optional.of(s);
      return this;
    }
    
    public Hierarchical build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      if (!fromCommandLine && !data_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing data");
      final GlobalDataSource __data = data;
      if (!fromCommandLine && !rocketType_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing rocketType");
      final Plate<String> __rocketType = rocketType;
      if (!fromCommandLine && !numberOfLaunches_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing numberOfLaunches");
      final Plated<IntVar> __numberOfLaunches = numberOfLaunches;
      if (!fromCommandLine && !failureProbabilities_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing failureProbabilities");
      final Plated<RealVar> __failureProbabilities = failureProbabilities;
      if (!fromCommandLine && !numberOfFailures_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing numberOfFailures");
      final Plated<IntVar> __numberOfFailures = numberOfFailures;
      RealVar mu;
      if (this.mu != null && this.mu.isPresent()) {
        mu = this.mu.get();
      } else {
        mu = $generated__14(data, rocketType, numberOfLaunches, failureProbabilities, numberOfFailures);
      }
      final RealVar __mu = mu;
      RealVar s;
      if (this.s != null && this.s.isPresent()) {
        s = this.s.get();
      } else {
        s = $generated__15(data, rocketType, numberOfLaunches, failureProbabilities, numberOfFailures, mu);
      }
      final RealVar __s = s;
      // Build the instance after boxing params
      return new Hierarchical(
        __failureProbabilities, 
        __numberOfFailures, 
        __mu, 
        __s, 
        new ConstantSupplier(__data), 
        new ConstantSupplier(__rocketType), 
        new ConstantSupplier(__numberOfLaunches)
      );
    }
  }
  
  @DesignatedConstructor
  public static Hierarchical.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  @Param
  private final Supplier<GlobalDataSource> $generated__data;
  
  public GlobalDataSource getData() {
    return $generated__data.get();
  }
  
  @Param
  private final Supplier<Plate<String>> $generated__rocketType;
  
  public Plate<String> getRocketType() {
    return $generated__rocketType.get();
  }
  
  @Param
  private final Supplier<Plated<IntVar>> $generated__numberOfLaunches;
  
  public Plated<IntVar> getNumberOfLaunches() {
    return $generated__numberOfLaunches.get();
  }
  
  private final Plated<RealVar> failureProbabilities;
  
  public Plated<RealVar> getFailureProbabilities() {
    return failureProbabilities;
  }
  
  private final Plated<IntVar> numberOfFailures;
  
  public Plated<IntVar> getNumberOfFailures() {
    return numberOfFailures;
  }
  
  private final RealVar mu;
  
  public RealVar getMu() {
    return mu;
  }
  
  private final RealVar s;
  
  public RealVar getS() {
    return s;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * mu
   */
  private static RealVar $generated__0(final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    return mu;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.5
   */
  private static RealVar $generated__1() {
    return new blang.core.RealConstant(0.5);
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "0.5";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 2
   */
  private static RealVar $generated__2() {
    return new blang.core.RealConstant(2);
  }
  
  public static class $generated__2_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__2();
    }
    
    public String toString() {
      return "2";
    }
    
    public $generated__2_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * s
   */
  private static RealVar $generated__3(final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    return s;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.1
   */
  private static RealVar $generated__4() {
    return new blang.core.RealConstant(0.1);
  }
  
  public static class $generated__4_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__4();
    }
    
    public String toString() {
      return "0.1";
    }
    
    public $generated__4_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * rocketType.indices
   */
  private static Iterable<Index<String>> $generated__5(final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    Collection<Index<String>> _indices = rocketType.indices();
    return _indices;
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbabilities.get(rocket)
   */
  private static RealVar $generated__6(final Index<String> rocket, final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    RealVar _get = failureProbabilities.get(rocket);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * mu
   */
  private static RealVar $generated__7(final RealVar mu, final RealVar s) {
    return mu;
  }
  
  public static class $generated__7_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__7(mu, s);
    }
    
    public String toString() {
      return "mu";
    }
    
    private final RealVar mu;
    
    private final RealVar s;
    
    public $generated__7_class(final RealVar mu, final RealVar s) {
      this.mu = mu;
      this.s = s;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * s
   */
  private static RealVar $generated__8(final RealVar mu, final RealVar s) {
    return s;
  }
  
  public static class $generated__8_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__8(mu, s);
    }
    
    public String toString() {
      return "s";
    }
    
    private final RealVar mu;
    
    private final RealVar s;
    
    public $generated__8_class(final RealVar mu, final RealVar s) {
      this.mu = mu;
      this.s = s;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbabilities.get(rocket)
   */
  private static RealVar $generated__9(final Index<String> rocket, final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    RealVar _get = failureProbabilities.get(rocket);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfLaunches.get(rocket)
   */
  private static IntVar $generated__10(final Index<String> rocket, final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    IntVar _get = numberOfLaunches.get(rocket);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfFailures.get(rocket)
   */
  private static IntVar $generated__11(final Index<String> rocket, final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu, final RealVar s) {
    IntVar _get = numberOfFailures.get(rocket);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfLaunch
   */
  private static IntVar $generated__12(final RealVar failureProbability, final IntVar numberOfLaunch) {
    return numberOfLaunch;
  }
  
  public static class $generated__12_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__12(failureProbability, numberOfLaunch);
    }
    
    public String toString() {
      return "numberOfLaunch";
    }
    
    private final RealVar failureProbability;
    
    private final IntVar numberOfLaunch;
    
    public $generated__12_class(final RealVar failureProbability, final IntVar numberOfLaunch) {
      this.failureProbability = failureProbability;
      this.numberOfLaunch = numberOfLaunch;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__13(final RealVar failureProbability, final IntVar numberOfLaunch) {
    return failureProbability;
  }
  
  public static class $generated__13_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__13(failureProbability, numberOfLaunch);
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    private final IntVar numberOfLaunch;
    
    public $generated__13_class(final RealVar failureProbability, final IntVar numberOfLaunch) {
      this.failureProbability = failureProbability;
      this.numberOfLaunch = numberOfLaunch;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__14(final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__15(final GlobalDataSource data, final Plate<String> rocketType, final Plated<IntVar> numberOfLaunches, final Plated<RealVar> failureProbabilities, final Plated<IntVar> numberOfFailures, final RealVar mu) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public Hierarchical(@DeboxedName("failureProbabilities") final Plated<RealVar> failureProbabilities, @DeboxedName("numberOfFailures") final Plated<IntVar> numberOfFailures, @DeboxedName("mu") final RealVar mu, @DeboxedName("s") final RealVar s, @Param @DeboxedName("data") final Supplier<GlobalDataSource> $generated__data, @Param @DeboxedName("rocketType") final Supplier<Plate<String>> $generated__rocketType, @Param @DeboxedName("numberOfLaunches") final Supplier<Plated<IntVar>> $generated__numberOfLaunches) {
    this.$generated__data = $generated__data;
    this.$generated__rocketType = $generated__rocketType;
    this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    this.failureProbabilities = failureProbabilities;
    this.numberOfFailures = numberOfFailures;
    this.mu = mu;
    this.s = s;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: mu ~ BetaMeanParam(0.5, 2)
      // Construction and addition of the factor/model:
      components.add(
        new ex.hm.BetaMeanParam(
          $generated__0($generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s), 
          new $generated__1_class(), 
          new $generated__2_class()
        )
        );
    }
    { // Code generated by: s ~ Exponential(0.1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__3($generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s), 
          new $generated__4_class()
        )
        );
    }
    for (Index<String> rocket : $generated__5($generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s)) {
      { // Code generated by: failureProbabilities.get(rocket) | mu, s ~ BetaMeanParam(mu, s)
        // Construction and addition of the factor/model:
        components.add(
          new ex.hm.BetaMeanParam(
            $generated__6(rocket, $generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s), 
            new $generated__7_class(mu, s), 
            new $generated__8_class(mu, s)
          )
          );
      }
      { // Code generated by: numberOfFailures.get(rocket) | RealVar failureProbability = failureProbabilities.get(rocket), IntVar numberOfLaunch = numberOfLaunches.get(rocket) ~ Binomial(numberOfLaunch, failureProbability)
        // Required initialization:
        RealVar failureProbability = $generated__9(rocket, $generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s);
        IntVar numberOfLaunch = $generated__10(rocket, $generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s);
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Binomial(
            $generated__11(rocket, $generated__data.get(), $generated__rocketType.get(), $generated__numberOfLaunches.get(), failureProbabilities, numberOfFailures, mu, s), 
            new $generated__12_class(failureProbability, numberOfLaunch), 
            new $generated__13_class(failureProbability, numberOfLaunch)
          )
          );
      }
    }
    
    return components;
  }
}
