package ex.hm

import java.util.Map
import blang.core.RealVar
import java.util.LinkedHashMap
import blang.types.Index
import blang.types.Plate
import blang.types.Plated
import org.eclipse.xtend.lib.annotations.Data
import bayonet.math.SpecialFunctions

class Utils {
  def static Map<String,RealVar> prediction(Plate<String> rocketType, Plate<Integer> launch, Plated<RealVar> intercept, Plated<RealVar> slope) {
    val it = new LinkedHashMap<String,RealVar>
    for (Index<String> rocket : rocketType.indices) {
      val x = launch.indices(rocket).size
      val beta0 = intercept.get(rocket)
      val beta1 = slope.get(rocket)
      put(rocket.key, new Logistic(beta0, beta1, x))
    }
    return it
  }
  
  @Data
  static class Logistic implements RealVar {
    val RealVar beta0
    val RealVar beta1
    val int x
    override doubleValue() {
      SpecialFunctions.logistic(beta0.doubleValue + beta1.doubleValue * x)
    }
    override toString() { "" + doubleValue }
  }
}